<?php
class Reportes extends CI_Controller
{
    public $cont;
    public function __construct()
    {
        parent::__construct();
        if ($this->session->userdata("login-user") != "L0g!nT3s0r3r!@") {
            $this->session->sess_destroy();
            redirect(site_url("login/sessionexpired"));
        }
        $this->load->model("mgeneral");
    }
    public function vista($vista, $data = array(), $rol = 0)
    {
        $data_menu = array(
            "roles" => $this->mgeneral->get_roles($this->session->userdata("usua_ide")),
            "cont" => $this->mgeneral->get_roles_cont($this->session->userdata("usua_ide")),
            "inst" => $this->mgeneral->get_data("*", "config", array("conf_ide = 1")),
            "rol" => $this->mgeneral->get_data("*", "roles r,modulos m", array("role_ide = $rol", "m.modu_ide = r.role_modu_ide")),
        );
        $this->load->view("sistema/vheader");
        $this->load->view("sistema/vmenu", $data_menu);
        $this->load->view($vista, $data);
        $this->load->view("sistema/vfooter");
    }
    /************************************************************************************/
    public function formreporte()
    {
        $data = array(
            "clasi" => $this->mgeneral->get_data("*", "clasificador", array("clas_lima = 'SI'"), "clas_descripcion"),
            "fechas" => $this->mgeneral->get_data(
                "
                now() as hoy,
                DATE_SUB(now(),interval WEEKDAY(now()) day) as lunes,
                DATE_ADD(now(),interval (4-WEEKDAY(now())) day) as domingo,
                DATE_SUB(now(),interval (day(now())-1) day) as primero,
                LAST_DAY(now()) as ultimo",
                "config"
            ),
        );
        $this->vista("reportes/vformreporte", $data, 8);
    }
    public function pdf_header()
    {
        $pdf = new Pdf('P', 'mm', 'A4', true, 'UTF-8', false);
        $pdf->SetCreator('victor.bejar.g@gmail.com');
        $pdf->SetAuthor('Victor Hugo Bejar Gonzales');
        //$pdf->SetTitle('Listado de Docentes de la Carrera Profesional de '.$this->session->userdata("carrera"));
        //$pdf->SetSubject('Listado');
        //$pdf->SetKeywords('Carga Academica Docente');
        //$pdf->SetHeaderData(site_url("img/minedu.png"),70,"","",array(255,255,255),array(255,255,255));
        $pdf->setFooterData($tc = array(255, 255, 255), $lc = array(255, 255, 255));
        /*$pdf->setHeaderFont(Array('', '', 10));
        $pdf->setFooterFont(Array('', '', 10));
        $pdf->SetMargins(15,20,15);*/
        $pdf->SetHeaderMargin(1);
        $pdf->SetFooterMargin(1);
        $pdf->SetAutoPageBreak(FALSE, PDF_MARGIN_BOTTOM);
        /*$pdf->setImageScale(PDF_IMAGE_SCALE_RATIO);*/
        $pdf->setFontSubsetting(false);
        $pdf->SetFont('Helvetica', '', 9, '', true);
        return $pdf;
    }
    public function poner_fondo($pdf)
    {
        $pdf->SetAlpha(0.25);
        $largo = 140;
        $izq = (210 - $largo) / 2;
        $file = site_url("img/logo.jpg");
        $pdf->Image($file, $izq, 80, $largo, 0, 'JPG', '', '', false, 300, '', false, false, 0, 'C', false, false);
        $pdf->SetAlpha(1);
    }
    public function pdf_resumen_fecha($pdf, $ini, $fin)
    {
        $resumen = $this->mgeneral->get_resumen_fecha($ini, $fin);
        $pdf->SetFont('Helvetica', '', 8, '', true);
        $datei = date_create($ini);
        $i = date_format($datei, 'd/m/Y');
        $datef = date_create($fin);
        $f = date_format($datef, 'd/m/Y');
        if ($this->cont + 4 + count($resumen) > 55) {
            $pdf->AddPage('P');
            $this->cont = 0;
            $this->poner_fondo($pdf);
        }
        $pdf->SetFont('Helvetica', 'B', 10, '', true);
        if ($ini == $fin)
            $pdf->Cell(40, 5, 'FECHA:  ' . $f, '', 1, 'L', 0, '', 0);
        else
            $pdf->Cell(60, 5, 'FECHA:  DEL ' . $i . " AL " . $f, '', 1, 'L', 0, '', 0);

        $pdf->SetFont('Helvetica', '', 7, '', true);
        $pdf->Cell(25, 5, 'CODIGO', 'B', 0, 'C', 0, '', 0);
        $pdf->Cell(90, 5, 'DESCRIPCION', 'B', 0, 'C', 0, '', 0);
        $pdf->Cell(25, 5, 'CANTIDAD', 'B', 0, 'R', 0, '', 0);
        $pdf->Cell(25, 5, 'PRECIO', 'B', 0, 'R', 0, '', 0);
        $pdf->Cell(25, 5, 'SUBTOTAL', 'B', 1, 'R', 0, '', 0);
        $suma = 0;
        $this->cont += 3;
        foreach ($resumen as $reg) {
            $pdf->Cell(25, 5, $reg->clas_codigo, '', 0, 'C', 0, '', 0);
            $pdf->Cell(90, 5, $reg->clas_descripcion, '', 0, 'L', 0, '', 0);
            $pdf->Cell(25, 5, $reg->cantidad, '', 0, 'R', 0, '', 0);
            $pdf->Cell(25, 5, $reg->deta_precio, '', 0, 'R', 0, '', 0);
            $pdf->Cell(25, 5, $reg->subtotal, '', 1, 'R', 0, '', 0);
            $suma = $suma + $reg->subtotal;
            $this->cont++;
        }
        $this->cont++;
        if ($ini == $fin) {
            $pdf->Cell(165, 5, "TOTAL DEL DIA", 'T', 0, 'R', 0, '', 0);
            $pdf->Cell(25, 5, number_format($suma, 2), 'T', 1, 'R', 1, '', 0);
        } else {
            $pdf->Cell(165, 5, "TOTAL RECAUDADO", 'T', 0, 'R', 0, '', 0);
            $pdf->Cell(25, 5, number_format($suma, 2), 'T', 1, 'R', 1, '', 0);
        }
        $pdf->Cell(0, 5, "", '', 1, 'R', 0, '', 0);
        return $suma;
    }
    public function pdf_reporte()
    {
        $ini = $this->input->get("ini");
        $fin = $this->input->get("fin");
        $fechas = $this->mgeneral->get_fechas($ini, $fin);
        $hoy = $this->mgeneral->get_data("conf_inst_nombre,conf_lugar,now() as hoy", "config");
        $this->cont = 6;
        $this->load->library('Pdf');
        $pdf = $this->pdf_header();
        $pdf->AddPage('P');
        $this->poner_fondo($pdf);
        $pdf->SetFillColor(200, 200, 200);

        $file = site_url("img/minedu.jpg");
        $x = 10;
        $y = 5;
        $pdf->Image($file, $x, $y, 40, 0, 'JPG', '', '', false, 300, '', false, false, 0, 'C', false, false);
        $pdf->SetFillColor(200, 200, 200);
        $pdf->SetFont('Helvetica', '', 7, '', true);
        $pdf->MultiCell(40, 4, $hoy[0]->conf_inst_nombre, 0, 'C', 0, 0, $x, $y + 9, true);
        $pdf->MultiCell(40, 4, "UNIDAD DE TESORERIA", '', 'C', 0, 0, $x, $y + 13, true);

        $pdf->SetFont('Helvetica', 'B', 14, '', true);
        $date = date_create($ini);
        $i = date_format($date, 'd/m/Y');
        $date = date_create($fin);
        $f = date_format($date, 'd/m/Y');
        $pdf->Cell(0, 5, "", '', 1, 'C', 0, '', 0);
        $pdf->Cell(0, 5, "REPORTE DE INGRESOS ", '', 1, 'C', 0, '', 0);
        $pdf->Cell(0, 5, "DEL " . $i . " AL " . $f, '', 1, 'C', 0, '', 0);
        $pdf->Cell(0, 5, "", '', 1, 'C', 0, '', 0);

        $total = 0;
        foreach ($fechas as $reg) {
            $total += $this->pdf_resumen_fecha($pdf, $reg->fecha, $reg->fecha);
        }
        if ($this->cont + 18 > 55) {
            $pdf->AddPage('P');
            $this->cont = 0;
            $this->poner_fondo($pdf);
        }
        $pdf->Cell(0, 10, "", '', 1, 'R', 0, '', 0);
        $pdf->SetFont('Helvetica', '', 10, '', true);
        $pdf->Cell(165, 5, "TOTAL RECAUDADO", 'T', 0, 'R', 1, '', 0);
        $pdf->Cell(25, 5, number_format($total, 2), 'T', 1, 'R', 1, '', 0);

        $this->load->library("Funciones");
        $fun = new Funciones();
        $tmp = explode(" ", $hoy[0]->hoy);
        $pdf->Cell(0, 5, $hoy[0]->conf_lugar . ", " . $fun->get_fecha($tmp[0]) . " - " . $tmp[1], '', 1, 'R', 0, '', 0);

        $pdf->Cell(0, 50, "", '', 1, 'C', 0, '', 0);

        $pdf->Cell(15, 5, "", '', 0, 'C', 0, '', 0);
        $pdf->Cell(65, 5, "Tesoreria", 'T', 0, 'C', 0, '', 0);
        $pdf->Cell(30, 5, "", '', 0, 'C', 0, '', 0);
        $pdf->Cell(65, 5, "Administracion", 'T', 0, 'C', 0, '', 0);
        $pdf->Cell(15, 5, "", '', 1, 'C', 0, '', 0);

        $pdf->Cell(15, 5, "", '', 0, 'C', 0, '', 0);
        $pdf->Cell(65, 5, "Firma y Sello", '', 0, 'C', 0, '', 0);
        $pdf->Cell(30, 5, "", '', 0, 'C', 0, '', 0);
        $pdf->Cell(65, 5, "Firma y Sello", '', 0, 'C', 0, '', 0);
        $pdf->Cell(15, 5, "", '', 1, 'C', 0, '', 0);

        $pdf->AddPage('P');
        $this->poner_fondo($pdf);
        $pdf->Image($file, $x, $y, 40, 0, 'JPG', '', '', false, 300, '', false, false, 0, 'C', false, false);
        $pdf->SetFillColor(200, 200, 200);
        $pdf->SetFont('Helvetica', '', 7, '', true);
        $pdf->MultiCell(40, 4, $hoy[0]->conf_inst_nombre, 0, 'C', 0, 0, $x, $y + 9, true);
        $pdf->MultiCell(40, 4, "UNIDAD DE TESORERIA", '', 'C', 0, 0, $x, $y + 13, true);

        $pdf->SetFont('Helvetica', 'B', 14, '', true);
        $pdf->Cell(0, 5, "", '', 1, 'C', 0, '', 0);
        $pdf->Cell(0, 5, "RESUMEN DEL REPORTE DE INGRESOS ", '', 1, 'C', 0, '', 0);
        $pdf->Cell(0, 5, "DEL " . $i . " AL " . $f, '', 1, 'C', 0, '', 0);
        $pdf->Cell(0, 5, "", '', 1, 'C', 0, '', 0);

        $this->pdf_resumen_fecha($pdf, $ini, $fin);

        $pdf->AddPage('P');
        $this->poner_fondo($pdf);
        $pdf->Image($file, $x, $y, 40, 0, 'JPG', '', '', false, 300, '', false, false, 0, 'C', false, false);
        $pdf->SetFillColor(200, 200, 200);
        $pdf->SetFont('Helvetica', '', 7, '', true);
        $pdf->MultiCell(40, 4, $hoy[0]->conf_inst_nombre, 0, 'C', 0, 0, $x, $y + 9, true);
        $pdf->MultiCell(40, 4, "UNIDAD DE TESORERIA", '', 'C', 0, 0, $x, $y + 13, true);

        $pdf->SetFont('Helvetica', 'B', 14, '', true);
        $pdf->Cell(0, 5, "", '', 1, 'C', 0, '', 0);
        $pdf->Cell(0, 5, "REPORTE DE INGRESOS ", '', 1, 'C', 0, '', 0);
        $pdf->Cell(0, 5, "DEPOSITO DE MONTOS PARA LIMA", '', 1, 'C', 0, '', 0);
        $pdf->Cell(0, 5, "", '', 1, 'C', 0, '', 0);

        $pdf->SetFont('Helvetica', '', 7, '', true);
        $pdf->Cell(25, 5, 'CODIGO', 'B', 0, 'C', 0, '', 0);
        $pdf->Cell(80, 5, 'DESCRIPCION', 'B', 0, 'L', 0, '', 0);
        $pdf->Cell(30, 5, 'UGEL', 'B', 0, 'C', 0, '', 0);
        $pdf->Cell(30, 5, 'LIMA', 'B', 0, 'C', 0, '', 0);
        $pdf->Cell(25, 5, 'TOTAL', 'B', 1, 'R', 0, '', 0);

        $lista = explode(",", $this->input->get("lista_clas"));
        $tugel = 0;
        $tlima = 0;
        for ($i = 0; $i < count($lista) - 1; $i++) {
            $ingreso = $this->mgeneral->get_resumen_fecha_clas($ini, $fin, $lista[$i]);
            if (count($ingreso) == 1) {
                $tmp_cod = $ingreso[0]->clas_codigo;
                $tmp_des = $ingreso[0]->clas_descripcion;
                $tmp_tot = $ingreso[0]->subtotal;
                $tmp_por_lima = $this->input->get("lima_" . $lista[$i]);
                $tmp_mon_lima = $tmp_por_lima * $tmp_tot / 100;
                $tmp_por_ugel = 100 - $tmp_por_lima;
                $tmp_mon_ugel = $tmp_tot - $tmp_mon_lima;
                $tugel += $tmp_mon_ugel;
                $tlima += $tmp_mon_lima;
            } else {
                $tmp = $this->mgeneral->get_data("clas_codigo,clas_descripcion", "clasificador", array("clas_ide = $lista[$i]"));
                $tmp_cod = $tmp[0]->clas_codigo;
                $tmp_des = $tmp[0]->clas_descripcion;
                $tmp_tot = 0;
                $tmp_por_lima = $this->input->get("lima_" . $lista[$i]);
                $tmp_mon_lima = $tmp_por_lima * $tmp_tot / 100;
                $tmp_por_ugel = 100 - $tmp_por_lima;
                $tmp_mon_ugel = $tmp_tot - $tmp_mon_lima;
            }
            $pdf->Cell(25, 5, $tmp_cod, '', 0, 'C', 0, '', 0);
            $pdf->Cell(80, 5, $tmp_des, '', 0, 'L', 0, '', 0);
            $pdf->Cell(10, 5, $tmp_por_ugel . "%", '', 0, 'R', 0, '', 0);
            $pdf->Cell(20, 5, number_format($tmp_mon_ugel, 2), '', 0, 'R', 0, '', 0);
            $pdf->Cell(10, 5, $tmp_por_lima . "%", '', 0, 'R', 0, '', 0);
            $pdf->Cell(20, 5, number_format($tmp_mon_lima, 2), '', 0, 'R', 0, '', 0);
            $pdf->Cell(25, 5, number_format($tmp_tot, 2), '', 1, 'R', 0, '', 0);
        }
        $pdf->Cell(105, 5, "TOTALES: ", 'T', 0, 'R', 0, '', 0);
        $pdf->Cell(30, 5, number_format($tugel, 2), 'T', 0, 'R', 1, '', 0);
        $pdf->Cell(30, 5, number_format($tlima, 2), 'T', 0, 'R', 1, '', 0);
        $pdf->Cell(25, 5, number_format($tugel + $tlima, 2), 'T', 1, 'R', 1, '', 0);

        $nombre_archivo = utf8_decode("reporte.pdf");
        $pdf->Output($nombre_archivo, 'I');
    }
    /************************************************************************************/
    public function casiresumen()
    {
        $this->vista("reportes/vcasiresumen", array(), 11);
    }
    public function pdf_reporte_casiresumen()
    {
        $mes = $this->input->get("mes");
        $anio = $this->input->get("anio");
        $config = $this->mgeneral->get_data("conf_inst_nombre,conf_lugar,now() as hoy", "config");
        $casi = $this->mgeneral->get_data(
            "   c.casi_fecha_deposito,
                ca.caja_nombre,
                c.casi_descripcion,
                f.form_nombre,
                c.casi_monto,
                c.casi_corresponde
            ",
            "   casillero c,
                cajas ca,
                formas f
            ",
            array(
                "c.casi_caja_ide = ca.caja_ide",
                "c.casi_form_ide = f.form_ide",
                "c.casi_mese_ide = $mes",
                "c.casi_anio = $anio",
                "c.casi_esta_ide = 1"
            ),
            "c.casi_fecha_deposito"
        );
        $casi_form = $this->mgeneral->get_casi_form($mes, $anio);
        $this->load->library("Funciones");
        $fun = new Funciones();
        $mes1 = strtoupper($fun->get_mes($mes));
        $this->load->library('Pdf');
        $pdf = $this->pdf_header();
        $pdf->AddPage('P');
        $this->poner_fondo($pdf);
        $file = site_url("img/minedu.jpg");
        $x = 10;
        $y = 5;
        $pdf->Image($file, $x, $y, 40, 0, 'JPG', '', '', false, 300, '', false, false, 0, 'C', false, false);
        $pdf->SetFillColor(200, 200, 200);
        $pdf->SetFont('Helvetica', '', 7, '', true);
        $pdf->MultiCell(40, 4, $config[0]->conf_inst_nombre, 0, 'C', 0, 0, $x, $y + 9, true);
        $pdf->MultiCell(40, 4, "UNIDAD DE TESORERIA", '', 'C', 0, 0, $x, $y + 13, true);

        $pdf->SetFont('Helvetica', 'B', 14, '', true);
        $pdf->Cell(0, 5, "", '', 1, 'C', 0, '', 0);
        $pdf->Cell(0, 5, "RDR USO DE CASILLEROS ", '', 1, 'C', 0, '', 0);
        $pdf->Cell(0, 5, $mes1 . " - " . $anio, '', 1, 'C', 0, '', 0);
        $pdf->Cell(0, 5, "", '', 1, 'C', 0, '', 0);

        $pdf->SetFont('Helvetica', '', 7, '', true);
        $pdf->Cell(20, 5, 'DEPOSITO', 'TB', 0, 'C', 0, '', 0);
        $pdf->Cell(60, 5, 'ENTIDAD', 'TB', 0, 'C', 0, '', 0);
        $pdf->Cell(30, 5, 'CONCEPTO', 'TB', 0, 'C', 0, '', 0);
        $pdf->Cell(30, 5, 'CORRESPONDE A', 'TB', 0, 'C', 0, '', 0);
        $pdf->Cell(30, 5, 'FORMA DE PAGO', 'TB', 0, 'C', 0, '', 0);
        $pdf->Cell(20, 5, 'MONTO', 'TB', 1, 'R', 0, '', 0);
        $total = 0;
        foreach ($casi as $reg) {
            $pdf->Cell(20, 5, $reg->casi_fecha_deposito, '', 0, 'C', 0, '', 0);
            $pdf->Cell(60, 5, $reg->caja_nombre, '', 0, 'L', 0, '', 0);
            $pdf->Cell(30, 5, $reg->casi_descripcion, '', 0, 'L', 0, '', 0);
            $pdf->Cell(30, 5, $reg->casi_corresponde, '', 0, 'C', 0, '', 0);
            $pdf->Cell(30, 5, $reg->form_nombre, '', 0, 'C', 0, '', 0);
            $pdf->Cell(20, 5, number_format($reg->casi_monto, 2), '', 1, 'R', 0, '', 0);
            $total = $total + $reg->casi_monto;
        }
        $pdf->Cell(170, 5, "TOTAL", 'T', 0, 'R', 0, '', 0);
        $pdf->Cell(20, 5, number_format($total, 2), 'T', 1, 'R', 1, '', 0);
        $pdf->Cell(30, 5, "", '', 1, 'C', 0, '', 0);
        $pdf->Cell(30, 5, "", '', 1, 'C', 0, '', 0);

        $pdf->Cell(170, 5, 'FORMA DE PAGO', 'TB', 0, 'L', 0, '', 0);
        $pdf->Cell(20, 5, 'MONTO', 'TB', 1, 'R', 0, '', 0);
        foreach ($casi_form as $reg) {
            $pdf->Cell(170, 5, $reg->form_nombre, '', 0, 'L', 0, '', 0);
            $pdf->Cell(20, 5, number_format($reg->monto, 2), '', 1, 'R', 0, '', 0);
        }
        $pdf->Cell(170, 5, "TOTAL", 'T', 0, 'R', 0, '', 0);
        $pdf->Cell(20, 5, number_format($total, 2), 'T', 1, 'R', 1, '', 0);

        $pdf->AddPage('P');
        $this->poner_fondo($pdf);
        $file = site_url("img/minedu.jpg");
        $x = 10;
        $y = 5;
        $pdf->Image($file, $x, $y, 40, 0, 'JPG', '', '', false, 300, '', false, false, 0, 'C', false, false);
        $pdf->SetFillColor(200, 200, 200);
        $pdf->SetFont('Helvetica', '', 7, '', true);
        $pdf->MultiCell(40, 4, $config[0]->conf_inst_nombre, 0, 'C', 0, 0, $x, $y + 9, true);
        $pdf->MultiCell(40, 4, "UNIDAD DE TESORERIA", '', 'C', 0, 0, $x, $y + 13, true);

        $pdf->SetFont('Helvetica', 'B', 14, '', true);
        $pdf->Cell(0, 5, "", '', 1, 'C', 0, '', 0);
        $pdf->Cell(0, 5, "RESUMEN DE INGRESOS MENSUALES", '', 1, 'C', 0, '', 0);
        $pdf->Cell(0, 5, $mes1 . " - " . $anio, '', 1, 'C', 0, '', 0);
        $pdf->Cell(0, 5, "", '', 1, 'C', 0, '', 0);

        $ini = "$anio-$mes-01";
        $fin = "$anio-$mes-31";
        $resumen = $this->mgeneral->get_resumen_fecha($ini, $fin);
        $suma_resumen = 0;
        foreach ($resumen as $reg) {
            $suma_resumen += $reg->subtotal;
        }

        $efec = $this->mgeneral->get_data("sum(casi_monto) as monto", "casillero", array("casi_mese_ide = $mes", "casi_anio = $anio", "casi_form_ide = 1"));
        $cheq = $this->mgeneral->get_data("*", "casillero c,cajas ca", array("casi_mese_ide = $mes", "casi_anio = $anio", "casi_form_ide = 2", "c.casi_caja_ide = ca.caja_ide"));

        $tefec = 0;
        if (count($efec) == 1) {
            $tefec = $efec[0]->monto;
        }
        $ttt = $suma_resumen + $tefec;

        $suma_resumen = number_format($suma_resumen, 2);
        $tefec = number_format($tefec, 2);

        $pdf->SetFont('Helvetica', 'B', 10, '', true);
        $pdf->Cell(150, 5, 'EFECTIVO', '', 1, 'L', 0, '', 0);
        $pdf->SetFont('Helvetica', '', 7, '', true);
        $pdf->Cell(170, 5, "CONCEPTO", 'B', 0, 'L', 0, '', 0);
        $pdf->Cell(20, 5, "MONTO", 'B', 1, 'R', 0, '', 0);
        $pdf->Cell(170, 5, "REDAUDACION MENSUAL", '', 0, 'L', 0, '', 0);
        $pdf->Cell(20, 5, $suma_resumen, '', 1, 'R', 0, '', 0);
        $pdf->Cell(170, 5, "USO DE CASILLERO", '', 0, 'L', 0, '', 0);
        $pdf->Cell(20, 5, $tefec, '', 1, 'R', 0, '', 0);
        $pdf->Cell(170, 5, "TOTAL EFECTIVO", 'T', 0, 'R', 0, '', 0);
        $pdf->Cell(20, 5, number_format($ttt, 2), 'T', 1, 'R', 1, '', 0);

        $pdf->Cell(50, 5, "", '', 1, 'R', 0, '', 0);

        $pdf->SetFont('Helvetica', 'B', 10, '', true);
        $pdf->Cell(150, 5, 'CHEQUE', '', 1, 'L', 0, '', 0);
        $pdf->SetFont('Helvetica', '', 7, '', true);
        $pdf->Cell(120, 5, 'ENTIDAD', 'B', 0, 'L', 0, '', 0);
        $pdf->Cell(50, 5, 'N° DE CHEQUE', 'B', 0, 'L', 0, '', 0);
        $pdf->Cell(20, 5, 'MONTO', 'B', 1, 'R', 0, '', 0);
        $ttt2 = 0;
        foreach ($cheq  as $reg) {
            $pdf->Cell(120, 5, $reg->caja_nombre, 'TB', 0, 'L', 0, '', 0);
            $pdf->Cell(50, 5, $reg->casi_descripcion, 'TB', 0, 'L', 0, '', 0);
            $pdf->Cell(20, 5, number_format($reg->casi_monto, 2), 'TB', 1, 'R', 0, '', 0);
            $ttt2 += $reg->casi_monto;
        }
        $pdf->Cell(170, 5, "TOTAL CHEQUE", 'T', 0, 'R', 0, '', 0);
        $pdf->Cell(20, 5, number_format($ttt2, 2), 'T', 1, 'R', 1, '', 0);

        $pdf->Cell(50, 5, "", '', 1, 'R', 0, '', 0);

        $pdf->SetFont('Helvetica', 'B', 10, '', true);
        $pdf->Cell(150, 5, 'TOTAL', '', 1, 'L', 0, '', 0);
        $pdf->SetFont('Helvetica', '', 7, '', true);
        $pdf->Cell(170, 5, 'CONCEPTO', 'B', 0, 'L', 0, '', 0);
        $pdf->Cell(20, 5, 'MONTO', 'B', 1, 'R', 0, '', 0);
        $pdf->Cell(170, 5, 'TOTAL EFECTIVO', '', 0, 'L', 0, '', 0);
        $pdf->Cell(20, 5, number_format($ttt, 2), '', 1, 'R', 0, '', 0);
        $pdf->Cell(170, 5, 'TOTAL CHEQUE', '', 0, 'L', 0, '', 0);
        $pdf->Cell(20, 5, number_format($ttt2, 2), '', 1, 'R', 0, '', 0);
        $pdf->Cell(170, 5, "TOTAL", 'T', 0, 'R', 0, '', 0);
        $pdf->Cell(20, 5, number_format($ttt + $ttt2, 2), 'T', 1, 'R', 1, '', 0);

        $nombre_archivo = utf8_decode("reporte.pdf");
        $pdf->Output($nombre_archivo, 'I');
    }
    /************************************************************************************/
    public function pdf_reporte_diario()
    {
        $f = $this->input->get("f");
        $ingresos = $this->mgeneral->get_resumen_fecha2($f, $f);
        $hoy = $this->mgeneral->get_data("conf_inst_nombre,conf_lugar,now() as hoy", "config");
        $this->cont = 6;
        $this->load->library('Pdf');
        $pdf = $this->pdf_header();
        $pdf->AddPage('P');
        $this->poner_fondo($pdf);
        $pdf->SetFillColor(200, 200, 200);

        $file = site_url("img/minedu.jpg");
        $x = 10;
        $y = 5;
        $pdf->Image($file, $x, $y, 40, 0, 'JPG', '', '', false, 300, '', false, false, 0, 'C', false, false);
        $pdf->SetFillColor(200, 200, 200);
        $pdf->SetFont('Helvetica', '', 7, '', true);
        $pdf->MultiCell(40, 4, $hoy[0]->conf_inst_nombre, 0, 'C', 0, 0, $x, $y + 9, true);
        $pdf->MultiCell(40, 4, "UNIDAD DE TESORERIA", '', 'C', 0, 0, $x, $y + 13, true);

        $pdf->SetFont('Helvetica', 'B', 14, '', true);
        $date = date_create($f);
        $f = date_format($date, 'd/m/Y');
        $pdf->Cell(0, 5, "", '', 1, 'C', 0, '', 0);
        $pdf->Cell(0, 5, "REPORTE DE INGRESOS DIARIOS", '', 1, 'C', 0, '', 0);
        $pdf->Cell(0, 5, $f, '', 1, 'C', 0, '', 0);
        $pdf->Cell(0, 5, "", '', 1, 'C', 0, '', 0);

        $pdf->SetFont('Helvetica', '', 7, '', true);
        $pdf->Cell(15, 5, 'RECIBO', 'B', 0, 'C', 0, '', 0);
        $pdf->Cell(15, 5, 'CODIGO', 'B', 0, 'C', 0, '', 0);
        $pdf->Cell(80, 5, 'DESCRIPCION', 'B', 0, 'C', 0, '', 0);
        $pdf->Cell(20, 5, 'CANTIDAD', 'B', 0, 'R', 0, '', 0);
        $pdf->Cell(20, 5, 'PRECIO', 'B', 0, 'R', 0, '', 0);
        $pdf->Cell(20, 5, 'SUBTOTAL', 'B', 0, 'R', 0, '', 0);
        $pdf->Cell(20, 5, 'ESTADO', 'B', 1, 'R', 0, '', 0);

        foreach ($ingresos as $reg) {
            $pdf->SetFont('Helvetica', '', 7, '', true);
            $pdf->Cell(15, 5, $reg->ingr_ide, 'B', 0, 'C', 0, '', 0);
            $pdf->Cell(15, 5, $reg->clas_codigo, 'B', 0, 'C', 0, '', 0);
            $pdf->Cell(80, 5, $reg->clas_descripcion, 'B', 0, 'C', 0, '', 0);
            $pdf->Cell(20, 5, $reg->deta_cantidad, 'B', 0, 'R', 0, '', 0);
            $pdf->Cell(20, 5, $reg->deta_precio, 'B', 0, 'R', 0, '', 0);
            $pdf->Cell(20, 5, $reg->subtotal, 'B', 0, 'R', 0, '', 0);
            $pdf->Cell(20, 5, $reg->esta_nombre, 'B', 1, 'R', 0, '', 0);
        }

        $suma = 0;

        $nombre_archivo = utf8_decode("reporte.pdf");
        $pdf->Output($nombre_archivo, 'I');
    }
    /************************************************************************************/
    public function listaclientes($estado = 0, $mora = 2)
    {
        $cliente = $this->input->get("clie");
        $clientes = $this->mgeneral->get_personas2($estado, $cliente);
        foreach ($clientes as $reg) {
            $reg->mora = $this->es_moroso($reg->pers_ide, $mora_meses);
            $reg->tiempo = $mora_meses;
        }
        $data = array(
            "titulo" => "LISTA DE CLIENTES",
            "clientes" => $clientes,
            //"estados"=>$this->mgeneral->get_data("*","estados",array("esta_ide >= 5","esta_ide <= 9")),
            "estados" => $this->mgeneral->get_data("*", "estados"),
            "esta" => $estado,
            "clie" => $cliente,
            "mora" => $mora
        );
        $this->vista("reportes/vlistaclientes", $data, 11);
    }
    /************************************************************************************/
    public function morosos()
    {
        $data = array(
            "titulo" => "MOROSOS"
        );
        $this->vista("reportes/vreportes", $data, 11);
    }
    /************************************************************************************/
    public function reconexiones()
    {
        $data = array(
            "titulo" => "RECONEXIONES"
        );
        $this->vista("reportes/vreportes", $data, 11);
    }
    /************************************************************************************/
    public function ingresos()
    {
        $ini = $this->input->post("ini");
        $fin = $this->input->post("fin");
        $usua = $this->input->post("usua");

        $ingresos = array();
        if ($ini != "") {
            $ingresos = $this->mgeneral->get_ingresos($ini, $fin);
        }
        /*if($ini==0 || $fin==0){
            $ingresos=array();
        }
        else{
            $ingresos=$this->mgeneral->get_ingresos($ini,$fin);
        }*/
        $data = array(
            "ingresos" => $ingresos,
            "ini" => $ini,
            "fin" => $fin,
            "usua" => $usua
        );
        $this->vista("reportes/vingresos", $data, 11);
    }
    /************************************************************************************/
    public function historial($pers)
    {
        $data = array(
            "historial" => $this->mgeneral->get_historial($pers),
            "suspens" => $this->mgeneral->get_data("*", "suspensiones", array("susp_pers_ide = $pers")),
            "pagos" => $this->mgeneral->get_pagos($pers),
            "apagar" => $this->mgeneral->get_meses_pagar($pers),
            "suspe" => $this->mgeneral->get_suspensiones($pers),
            "moroso" => $this->es_moroso($pers, $mora)
        );
        $this->vista("reportes/vhistorial", $data, 11);
    }
    public function es_moroso($pers, &$tiempo)
    {
        $pagos = $this->mgeneral->get_pagos($pers);
        $apagar = $this->mgeneral->get_meses_pagar($pers);
        $suspe = $this->mgeneral->get_suspensiones($pers);
        $tiempo = $apagar[0]->meses - $pagos[0]->pagos - $suspe[0]->suspe;
        if ($tiempo > 0) {
            return 1;
        }
        return 0;
    }
    /************************************************************************************/
    /************************************************************************************/
    /************************************************************************************/
}
