<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Mgeneral extends CI_Model {
	public function get_data($campos,$tabla,$where=false,$orden=false){
		$this->db->select($campos,false);
		$this->db->from($tabla);
		if($where!=false){
			foreach ($where as $reg) {
				$this->db->where($reg);
			}
		}
		if($orden!=false)
			$this->db->order_by($orden);
		$query=$this->db->get();
		if($query->num_rows()>0){
			return $query->result();
		}
		return array();
	}
	public function actualizar($tabla,$where,$data){
		$this->db->where($where);
		$this->db->update($tabla,$data);
		return $this->db->affected_rows();
	}
	public function insertar($tabla,$data){
		$this->db->insert($tabla,$data);
		return $this->db->affected_rows();
	}
	public function eliminar($tabla,$where){
		$this->db->delete($tabla,$where);
		return $this->db->affected_rows();
	}
	public function get_roles($usua_ide){
		$this->db->select("
			upper(m.modu_nombre) as modulo,
			r.role_ico,
			r.role_nombre,
			r.role_url
		",false);
		$this->db->from("
			accesos a,
			roles r,
			modulos m
		");
		$this->db->where("a.acce_usua_ide",$usua_ide);
		$this->db->where("a.acce_role_ide = r.role_ide");
		$this->db->where("m.modu_ide = r.role_modu_ide");
		$this->db->where("r.role_estado","ACTIVO");
		$this->db->order_by("r.role_orden");
		$query=$this->db->get();
		if($query->num_rows()>0){
			return $query->result();
		}
		return array();
	}
	public function get_roles_cont($usua_ide){
		$this->db->select("
			upper(m.modu_nombre) as modulo,
			m.modu_nombre,
			m.modu_icono,
			r.role_nombre,
			r.role_url,
			count(*) as cont
		",false);
		$this->db->from("
			accesos a,
			roles r,
			modulos m
		");
		$this->db->where("a.acce_usua_ide",$usua_ide);
		$this->db->where("a.acce_role_ide = r.role_ide");
		$this->db->where("m.modu_ide = r.role_modu_ide");
		$this->db->where("r.role_estado","ACTIVO");
		$this->db->group_by("m.modu_ide");
		$this->db->order_by("m.modu_ide");
		$query=$this->db->get();
		if($query->num_rows()>0){
			return $query->result();
		}
		return array();
	}
	public function get_fecha(){
		$this->db->select("
			now() as fecha
		",false);
		$query=$this->db->get();
		if($query->num_rows()>0){
			return $query->result();
		}
		return array();
	}
	public function ultimo_id(){
		$this->db->select("
			last_insert_id() as id
		",false);
		$query=$this->db->get();
		if($query->num_rows()>0){
			$result=$query->result();
			return $result[0]->id;
		}
		return false;
	}
	public function get_clasificador($term){
		$this->db->select("
			*
		",false);
		$this->db->from("
			clasificador c
		");
		$this->db->like('clas_descripcion',$term);
		$this->db->order_by("c.clas_descripcion");
		$query=$this->db->get();
		if($query->num_rows()>0){
			return $query->result();
		}
		return array();
	}
	public function get_fechas($ini,$fin){
		$this->db->select("
			substr(ingr_fecha,1,10) as fecha
		",false);
		$this->db->from("
			ingresos i
		");
		$this->db->where("i.ingr_fecha >= '$ini 00:00:01'");
		$this->db->where("i.ingr_fecha <= '$fin 23:59:59'");
		$this->db->group_by("fecha");
		$this->db->order_by("fecha asc");
		$query=$this->db->get();
		if($query->num_rows()>0){
			return $query->result();
		}
		return array();
	}
	public function get_resumen_fecha($ini,$fin){
		$this->db->select("
			i.ingr_ide,
			c.clas_codigo,
			c.clas_descripcion,
			sum(d.deta_cantidad) as cantidad,
			d.deta_precio,
			sum(d.deta_cantidad)*d.deta_precio as subtotal
		",false);
		$this->db->from("
			detalle d,
			ingresos i,
			clasificador c
		");
		$this->db->where("i.ingr_ide = d.deta_ingr_ide");
		$this->db->where("c.clas_ide = d.deta_clas_ide");
		$this->db->where("i.ingr_fecha >= '$ini 00:00:01'");
		$this->db->where("i.ingr_fecha <= '$fin 23:59:59'");
		$this->db->where("i.ingr_esta_ide = 1");
		$this->db->where("d.deta_esta_ide = 1");
		$this->db->group_by("c.clas_ide");
		$this->db->order_by("c.clas_descripcion");
		$query=$this->db->get();
		if($query->num_rows()>0){
			return $query->result();
		}
		return array();
	}
	public function get_resumen_fecha2($ini,$fin){
		$this->db->select("
			i.ingr_ide,
			c.clas_codigo,
			c.clas_descripcion,
			d.deta_cantidad,
			d.deta_precio,
			d.deta_cantidad*d.deta_precio as subtotal,
			if(e.esta_ide=4,'ANULADO','') as estado,
			e.esta_nombre
		",false);
		$this->db->from("
			detalle d,
			ingresos i,
			clasificador c,
			estados e
		");
		$this->db->where("i.ingr_ide = d.deta_ingr_ide");
		$this->db->where("c.clas_ide = d.deta_clas_ide");
		$this->db->where("i.ingr_fecha >= '$ini 00:00:01'");
		$this->db->where("i.ingr_fecha <= '$fin 23:59:59'");
		$this->db->where("i.ingr_esta_ide = 1");
		$this->db->where("d.deta_esta_ide = 1");
		$this->db->where("i.ingr_esta_ide = e.esta_ide");
		$this->db->order_by("i.ingr_ide");
		$query=$this->db->get();
		if($query->num_rows()>0){
			return $query->result();
		}
		return array();
	}
	public function get_resumen_fecha_clas($ini,$fin,$clas){
		$this->db->select("
			c.clas_codigo,
			c.clas_descripcion,
			sum(d.deta_cantidad)*d.deta_precio as subtotal
		",false);
		$this->db->from("
			detalle d,
			ingresos i,
			clasificador c
		");
		$this->db->where("i.ingr_ide = d.deta_ingr_ide");
		$this->db->where("c.clas_ide = d.deta_clas_ide");
		$this->db->where("i.ingr_fecha >= '$ini 00:00:01'");
		$this->db->where("i.ingr_fecha <= '$fin 23:59:59'");
		$this->db->where("i.ingr_esta_ide = 1");
		$this->db->where("d.deta_esta_ide = 1");
		$this->db->where("c.clas_ide = $clas");
		$query=$this->db->get();
		if($query->num_rows()>0){
			return $query->result();
		}
		return array();
	}
	public function get_casi_form($mes,$anio){
		$this->db->select("
			f.form_nombre,
			sum(c.casi_monto) as monto
		",false);
		$this->db->from("
			casillero c,
			formas f
		");
		$this->db->where("c.casi_form_ide = f.form_ide");
		$this->db->where("c.casi_mese_ide = $mes");
		$this->db->where("c.casi_anio = $anio");
		$this->db->group_by("c.casi_form_ide");
		$this->db->order_by("c.casi_form_ide asc");
		$query=$this->db->get();
		if($query->num_rows()>0){
			return $query->result();
		}
		return array();
	}
	public function get_personas($esta=0){
		$this->db->select("
			*
		",false);
		$this->db->from("
			personas p,
			servicios s,
			estados e
		");
		$this->db->where("p.pers_serv_ide = s.serv_ide");
		$this->db->where("p.pers_esta_ide = e.esta_ide");
		if($esta!=0){
			$this->db->where_in("p.pers_esta_ide",$esta);
		}
		$this->db->where("pers_esta_ide < 100");
		$this->db->order_by("p.pers_nombres, p.pers_apellidos");
		$query=$this->db->get();
		if($query->num_rows()>0){
			return $query->result();
		}
		return array();
	}
	public function get_personas2($esta=0,$clie){
		$this->db->select("
			*
		",false);
		$this->db->from("
			personas p,
			servicios s,
			estados e
		");
		$this->db->where("p.pers_serv_ide = s.serv_ide");
		$this->db->where("p.pers_esta_ide = e.esta_ide");
		if($esta!=0){
			$this->db->where_in("p.pers_esta_ide",$esta);
		}
		//$this->db->where("pers_esta_ide < 100");
		$this->db->where("(pers_nombres like '%$clie%' OR pers_apellidos like '%$clie%')");
		$this->db->order_by("p.pers_nombres, p.pers_apellidos");
		$query=$this->db->get();
		if($query->num_rows()>0){
			return $query->result();
		}
		return array();
	}
	public function get_ingreso($ide){
		$this->db->select("
			*
		",false);
		$this->db->from("
			ingresos i,
			personas p,
			servicios s
		");
		$this->db->where("i.ingr_ide",$ide);
		$this->db->where("i.ingr_pers_ide = p.pers_ide");
		$this->db->where("p.pers_serv_ide = s.serv_ide");
		$query=$this->db->get();
		if($query->num_rows()>0){
			return $query->result();
		}
		return array();
	}
	public function get_historial($pers){
		$this->db->select("
		    i.ingr_ide,
			c.clas_descripcion,
			i.ingr_serie,
			i.ingr_numero,
			i.ingr_fecha,
			i.ingr_observacion,
			d.deta_cantidad,
			d.deta_precio
		",false);
		$this->db->from("
			detalle d,
			ingresos i,
			clasificador c
		");
		$this->db->where("i.ingr_ide = d.deta_ingr_ide");
		$this->db->where("i.ingr_pers_ide = $pers");
		$this->db->where("d.deta_clas_ide = c.clas_ide");
		$this->db->where("c.clas_mensualidad = 'SI'");
		$this->db->where("d.deta_esta_ide = 1");
		$this->db->where("i.ingr_esta_ide = 1");
		$this->db->order_by("d.deta_ide asc");
		$query=$this->db->get();
		if($query->num_rows()>0){
			return $query->result();
		}
		return array();
	}
	public function get_pagos($pers_ide){
		$this->db->select("
			SUM(d.deta_cantidad) AS pagos
		",false);
		$this->db->from("
			personas p,
			ingresos i,
			detalle d,
			clasificador c
		");
		$this->db->where("i.ingr_pers_ide = p.pers_ide");
		$this->db->where("i.ingr_ide = d.deta_ingr_ide");
		$this->db->where("d.deta_clas_ide = c.clas_ide");
		$this->db->where("d.deta_esta_ide = 1");
		$this->db->where("c.clas_mensualidad = 'SI'");
		$this->db->where("i.ingr_pers_ide = $pers_ide");
		$query=$this->db->get();
		if($query->num_rows()>0){
			return $query->result();
		}
		return array();
	}
	public function get_meses_pagar($pers_ide){
		$this->db->select("
			DATE_FORMAT(p.pers_finstalacion, '%d/%m/%Y') AS instala,
			if(
				p.pers_esta_ide = 6,
				DATE_FORMAT(NOW(), '%d/%m/%Y'),
				DATE_FORMAT(p.pers_fcorte, '%d/%m/%Y')
			) AS actual,
			if(
				p.pers_esta_ide = 6,
				(YEAR(NOW())-YEAR(p.pers_finstalacion))*12+(MONTH(NOW())-MONTH(p.pers_finstalacion))+1,
				(YEAR(p.pers_fcorte)-YEAR(p.pers_finstalacion))*12+(MONTH(p.pers_fcorte)-MONTH(p.pers_finstalacion))+1
			) AS meses,
			COUNT(*)
		",false);
		$this->db->from("
			personas p
		");
		$this->db->where("p.pers_ide = $pers_ide");
		$this->db->where("(p.pers_esta_ide = 6 OR p.pers_esta_ide = 100 OR p.pers_esta_ide = 7 OR p.pers_esta_ide = 8)");
		$query=$this->db->get();
		if($query->num_rows()>0){
			return $query->result();
		}
		return array();
	}
	public function get_suspensiones($pers_ide){
		$this->db->select("
			SUM((YEAR(s.susp_fin)-YEAR(s.susp_ini))*12+(MONTH(s.susp_fin)-MONTH(s.susp_ini))+1) AS suspe
		",false);
		$this->db->from("
			suspensiones s
		");
		$this->db->where("s.susp_pers_ide = $pers_ide");
		$this->db->where("s.susp_ini >= NOW()");
		$query=$this->db->get();
		if($query->num_rows()>0){
			return $query->result();
		}
		return array();
	}
	public function get_ingresos($ini,$fin){
		$this->db->select("
			concat(p.pers_apellidos,' ',p.pers_nombres) AS datos,
			c.clas_descripcion,
			i.ingr_serie,
			i.ingr_numero,
			i.ingr_fecha,
			i.ingr_observacion,
			d.deta_cantidad,
			d.deta_precio
		",false);
		$this->db->from("
			detalle d,
			ingresos i,
			clasificador c,
			personas p
		");
		$this->db->where("p.pers_ide = i.ingr_pers_ide");
		$this->db->where("i.ingr_ide = d.deta_ingr_ide");
		$this->db->where("d.deta_clas_ide = c.clas_ide");
		$this->db->where("d.deta_esta_ide = 1");
		$this->db->where("i.ingr_esta_ide = 1");
		$this->db->where("i.ingr_fecha >= '$ini'");
		$this->db->where("i.ingr_fecha <= '$fin'");
		$query=$this->db->get();
		if($query->num_rows()>0){
			return $query->result();
		}
		return array();
	}
}